		.title	HIOCS PLUS v16.11 (hiocs.s)

*****************************************************************
*	HIOCS version 1.10
*		< HIOCS.HAS >
*	$Id: HIOCS.HA_ 1.6 93/02/15 00:39:30 YuNK Exp $
*
*		Copyright 1990-93  SHARP / Y.Nakamura
*****************************************************************


* Include Files ----------------------- *

		.include	doscall.mac
		.include	iocscall.mac
		.include	hiocs.equ


* Global Symbols ---------------------- *

		.xref	dev_header
		.xref	csrwink
		.xref	timercint
		.xref	sccbrcv
		.xref	FONTANK6,FONTKNJ16A,FONTKNJ16C
		.xref	LOGBUFVECT
		.xref	STDOUTPTR
* ROMPATCH
		.xref	patchbegin,patchend,gpalet,dmamove,ms_patst,ontime
.ifdef HONTIME
		.xref	hontime_table
.endif
* CONDRV
		.xref	putc,putc_log,putc_escsq0
* rteC
		.xref	os_curon_rte,mscdraw_rte,mscerase_rte,txyline_rte,txline_rte,ontime_rte
* MOUSE
		.xref	mscdrawA,msceraseA,msctrlsetA,msctrlsetB,msdpatch1,msdpatch2,msepatch1,msepatch2

		.xref	akconv,jissft,sftjis
		.xref	b_clr_st,b_del,b_era_st,b_ins
		.xref	b_down,b_down_s,b_left,b_locate,b_right,b_up,b_up_s
		.xref	b_color,b_conmod,b_consol,defchr
		.xref	b_curoff,b_curon,os_curof,os_curon
		.xref	b_print,b_putc,b_putmes
		.xref	box,circle,fill,drawmode,getgrm,line,paint,point,pset,putgrm,symbol,wipe
		.xref	chr_adr,fntadr,fntget,putchar
		.xref	ms_curgt,ms_curof,ms_curon,ms_curst,ms_getdt,ms_init,ms_stat,ms_vcs
		.xref	txbox,txfill,txline,txrev,txxline,txyline
		.xref	fputc,fputs,conctrl,inpout,print,write
		.xref	clear_mpu_cache


* Fixed Numbers ----------------------- *

FONTSIZE0:	.equ	4096		*p̃tHgTCY
FONTSIZE1:	.equ	49216-4096	*ihr񊿎
FONTSIZE2:	.equ	145472-49216	*ihrP
FONTSIZE3:	.equ	286848-145472	*ihrQ


* Macros ------------------------------ *

PRINT:		.macro	adr
		pea	adr
		DOS	_PRINT
		addq.l	#4,sp
		.endm


* Text Section ------------------------ *

		.text
		.even
checkstr:
		.dc.b	HIOCS_ID,version		*(16bytes)
		.dc.b	'IOCS'


*************************************************
*	trap #15 (IOCSĂяo) [`	*
*************************************************

iocscall:
		move.l	a0,-(sp)
.if CPU>=68020
		andi.l	#$00ff,d0
		move	d0,(IOCSNUM)
		jsr	([$400,d0.w*4])
.else
		andi	#$00ff,d0
		ext.l	d0
		move	d0,(IOCSNUM)
		movea.l	d0,a0
		adda	a0,a0
		adda	a0,a0
		movea.l	($400,a0),a0
		jsr	(a0)
.endif
		move	#-1,(IOCSNUM)
		movea.l	(sp)+,a0
		rte


*************************************************
*	IOCS/DOSR[xN^ύX		*
*************************************************

setvect:
	tst.b	(a1)			*trap #15xN^
	bne	setvect1		*łɕύXĂ
	tst.b	(a0)
	beq	setvect1		*ύXȂ

	lea	(OLDTRAPVC,pc),a2
	move.l	(TRAPFVEC),a3
	move.l	a3,(a2)
	cmpa.l	#$ff0000,a3
	bcs	setvect1		*trap #15͕ύXĂ
	lea	(iocscall,pc),a2
	move.l	a2,(TRAPFVEC)
	st	(a1)
setvect1:
		tst.b	(1,a1)		*IOCSo̓xN^
		bne	setvect2	*łɕύXĂ
		move.b	(1,a0),(1,a1)
		beq	setvect2	*ύXȂ

		IOCS	_B_CUROFF	*<+08
		lea	(CSRDRLINE),a2
		moveq	#3,d0
		and	(a2),d0
		bne	@f
		cmpi	#16*4,(a2)
		bcs	csrdrline_ok
@@:
		move.l	#0<<16+$ffff,(a2)
csrdrline_ok:
		lea	(iocsctbl,pc),a3
		bsr	chgvecttbl_iocs	*IOCSxN^ύX

	lea	(OLDCSRVC,pc),a2
	move.l	(CSRTADR),(a2)		*timer-C J[\_ŏAhX
	lea	(csrwink,pc),a2
	move.l	a2,(CSRTADR)
	IOCS	_B_CURON		*<+08

	lea	(OLDTIMERCVC,pc),a2
	clr.l	(a2)
	move.l	(TIMERCVEC),a3		*timer-C 荞ݏAhX
	cmpa.l	#$ff0000,a3
	bcs	setvect13		*timer-C͕ύXĂ

		move.l	a3,(a2)
		lea	(timercint,pc),a2
		move.l	a2,(TIMERCVEC)
setvect13:
		bsr	check_condrv_mark
		bne	setvect2	*CONDRV.SYS͏풓ĂȂ

		lea	(LOGBUFVECT,pc),a3
		move.l	(-16,a2),(a3)+
		pea	(-28,a2)	*CONDRV.SYS̃IvV̊i[AhX
		move.l	(sp)+,(a3)+	*CONDFLAG
		.if	1
		move.l	(-22,a2),(a3)	*CONDSYSCALL
		.endif

		lea	(CONDRVPATCH,pc),a2
		lea	(putc,pc),a3	*CONDRV.SYSp̃pb`ĂsȂ
		move.l	(a3),(a2)+
		move.l	#BRA_W<<16+.loww.(putc_log-(putc+2)),(a3)
		addq.b	#(BNE_W-BRA_W)>>8,(putc_escsq0-putc,a3)
*		lea	(CONDRVFLG,pc),a2
		st	(a2)

		bsr	clear_mpu_cache
setvect2:
	tst.b	(2,a1)			*IOCSOtBbN`xN^
	bne	setvect3		*łɕύXĂ
	move.b	(2,a0),(2,a1)
	beq	setvect3		*ύXȂ

	lea	(iocsgtbl,pc),a3
	bsr	chgvecttbl_iocs		*IOCSxN^ύX
setvect3:
	tst.b	(3,a1)			*DOSo̓xN^
	bne	setvect4		*łɕύXĂ
	move.b	(3,a0),(3,a1)
	beq	setvect4		*ύXȂ

	bsr	seahumanptr		*stdoutt@Cnh|C^
	move.l	(STDOUTPTR,pc),d0
	beq	setvect4
	lea	($1800),a2
	lea	(dosctbl,pc),a3
	bsr	chgvecttbl		*DOSxN^ύX

setvect4:
	tst.b	(4,a1)			*IOCS}EXxN^
	bne	setvect10		*łɕύXĂ
	move.b	(4,a0),(4,a1)
	beq	setvect10		*ύXȂ

	lea	(iocsmtbl,pc),a3
	bsr	chgvecttbl_iocs		*IOCSxN^ύX

	lea	(OLDMSCVC,pc),a2
	clr.l	(a2)
	move.l	(MSTADR),a3
	cmpa.l	#$ff0000,a3
	bcs	setvect5		*}EXMv͕ύXĂ
	move.l	(SCCBRCVEC),a3
	cmpa.l	#$ff0000,a3
	bcs	setvect5		*SCCM͕ύXĂ

	move	sr,d0
	ori	#$0700,sr		*荞݋֎~
	lea	(OLDMSCVC,pc),a2
	move.l	(MSTADR),(a2)		*timer-C }EXMv
	lea	(msctrlsetA,pc),a2
	move.l	a2,(MSTADR)
	clr.b	(MSCTRLFLG)
	lea	(OLDSCCBVC,pc),a2
	move.l	(SCCBRCVEC),(a2)+	*SCC-BM
	move.l	(SCCBRCVEC2),(a2)
	lea	(sccbrcv,pc),a2
	move.l	a2,(SCCBRCVEC)
	move.l	a2,(SCCBRCVEC2)
	move	d0,sr
setvect5:
	moveq	#0,d1
	IOCS	_SETMSADR		*}EXJ[\\AhXύX
setvect10:
		moveq	#0,d0
		rts

check_condrv_mark:
		movea.l	(_KEY_INIT*4+$400),a2
		cmpi.l	#'hmk*',(-4,a2)
chgvecttbl2:
		rts

*	IOCS/DOSxN^ύX

chgvecttbl_iocs:
		lea	($400),a2
chgvecttbl:
		move.l	a3,d1
chgvecttbl1:
		move	(a3)+,d0
		bmi	chgvecttbl2

		add	d0,d0
		add	d0,d0
		movea.l	d1,a4
		adda	(a3)+,a4	*ύXAhX
		move.l	(a2,d0.w),(a3)+	*݂̃xN^ۑ
		move.l	a4,(a2,d0.w)	*xN^ύX
		bra	chgvecttbl1

*	DOSt@Cnhobt@

seahumanptr:				*<+03
	movem.l	d0-d7/a0-a6,-(sp)
	clr.l	-(sp)
	movea.l	sp,a6
	movea.l	(.low.(_DUP0)*4+$1800),a0
	jsr	(a0)
	addq.l	#4,sp
	move.l	a0,d0
	addq.l	#3,d0
	lea	(STDOUTPTR,pc),a0
	move.l	d0,(a0)
	movem.l	(sp)+,d0-d7/a0-a6
	rts



*************************************************
*	IOCS/DOSR[xN^̒lɖ߂	*
*************************************************

*	AxN^ύXĂȂǂ`FbN

restorevect:
	tst.b	(a1)			*trap #15xN^
	beq	restorevect1		*ύXĂȂ
	tst.b	(a0)
	bne	restorevect1		*̒lɖ߂Ȃ

	lea	(iocscall,pc),a2
	cmpa.l	(TRAPFVEC),a2
	bne	restorevect99

restorevect1:
	tst.b	(1,a1)			*IOCSo̓xN^
	beq	restorevect2		*ύXĂȂ
	tst.b	(1,a0)
	bne	restorevect2		*̒lɖ߂Ȃ

	lea	(iocsctbl,pc),a3
	bsr	chkvecttbl_iocs
	bne	restorevect99
	lea	(csrwink,pc),a2
	cmpa.l	(CSRTADR),a2
	bne	restorevect99

	move.l	(OLDTIMERCVC,pc),d0
	beq	restorevect15		*timer-CxN^͕ύXĂȂ
	lea	(timercint,pc),a2
	cmpa.l	(TIMERCVEC),a2
	bne	restorevect99

restorevect15:
		move.b	(CONDRVFLG,pc),d0
		beq	restorevect2	*CONDRV.SYS͏풓ĂȂ

		bsr	check_condrv_mark
		bne	restorevect99
restorevect2:
	tst.b	(2,a1)			*IOCSOtBbN`xN^
	beq	restorevect3		*ύXĂȂ
	tst.b	(2,a0)
	bne	restorevect3		*̒lɖ߂Ȃ

	lea	(iocsgtbl,pc),a3
	bsr	chkvecttbl_iocs
	bne	restorevect99

restorevect3:
	tst.b	(3,a1)			*DOSo̓xN^
	beq	restorevect4		*ύXĂȂ
	tst.b	(3,a0)
	bne	restorevect4		*̒lɖ߂Ȃ

	lea	($1800),a2
	lea	(dosctbl,pc),a3
	bsr	chkvecttbl
	bne	restorevect99

restorevect4:
	tst.b	(4,a1)			*IOCS}EXxN^
	beq	restorevect50		*ύXĂȂ
	tst.b	(4,a0)
	bne	restorevect50		*̒lɖ߂Ȃ

	lea	(iocsmtbl,pc),a3
	bsr	chkvecttbl_iocs
	bne	restorevect99

	move.l	(OLDMSCVC,pc),d0
	beq	restorevect50		*}EXMv/SCCM͕ύXĂȂ

	move.l	(MSTADR),a3
	lea	(msctrlsetA,pc),a2	*{̑}EXMv[`
	cmpa.l	a3,a2
	beq	restorevect5
	lea	(msctrlsetB,pc),a2	*L[{[h}EXMv[`
	cmpa.l	a3,a2
	bne	restorevect99
restorevect5:

	lea	(sccbrcv,pc),a2
	cmpa.l	(SCCBRCVEC),a2
	bne	restorevect99
	cmpa.l	(SCCBRCVEC2),a2
	bne	restorevect99

*	xN^̒lɖ߂

restorevect50:
	tst.b	(a1)			*trap #15xN^
	beq	restorevect51		*ύXĂȂ
	move.b	(a0),(a1)
	bne	restorevect51		*̒lɖ߂Ȃ

	move.l	(OLDTRAPVC,pc),(TRAPFVEC)

restorevect51:
	tst.b	(1,a1)			*IOCSo̓xN^
	beq	restorevect52		*ύXĂȂ
	move.b	(1,a0),(1,a1)
	bne	restorevect52		*̒lɖ߂Ȃ

	IOCS	_B_CUROFF		*<+03
	lea	(iocsctbl,pc),a3
	bsr	rstvecttbl_iocs
	move.l	(OLDCSRVC,pc),(CSRTADR)
	IOCS	_B_CURON		*<+03

	move.l	(OLDTIMERCVC,pc),d0
	beq	restorevect513		*timer-CxN^͕ύXĂȂ
	move.l	d0,(TIMERCVEC)

restorevect513:
		move.b	(CONDRVFLG,pc),d0
		beq	restorevect52	*CONDRV.SYS͏풓ĂȂ

		lea	(CONDRVPATCH,pc),a2
		lea	(putc,pc),a3
		move.l	(a2)+,(a3)
*		lea	(CONDRVFLG,pc),a2
		sf	(a2)

		bsr	clear_mpu_cache
restorevect52:
	tst.b	(2,a1)			*IOCSOtBbN`xN^
	beq	restorevect53		*ύXĂȂ
	move.b	(2,a0),(2,a1)
	bne	restorevect53		*̒lɖ߂Ȃ

	lea	(iocsgtbl,pc),a3
	bsr	rstvecttbl_iocs

restorevect53:
	tst.b	(3,a1)			*DOSo̓xN^
	beq	restorevect54		*ύXĂȂ
	move.b	(3,a0),(3,a1)
	bne	restorevect54		*̒lɖ߂Ȃ

	lea	($1800),a2
	lea	(dosctbl,pc),a3
	bsr	rstvecttbl

restorevect54:
	tst.b	(4,a1)			*IOCS}EXxN^
	beq	restorevect60		*ύXĂȂ
	move.b	(4,a0),(4,a1)
	bne	restorevect60		*̒lɖ߂Ȃ

	lea	(iocsmtbl,pc),a3
	bsr	rstvecttbl_iocs

	move.l	(OLDMSCVC,pc),d0
	beq	restorevect55		*}EXMv/SCCM͕ύXĂȂ

	move	sr,d0
	ori	#$0700,sr		*荞݋֎~
	move.l	(OLDMSCVC,pc),(MSTADR)	*timer-C }EXMv
	clr.b	(MSCTRLFLG)
	move.l	(OLDSCCBVC,pc),(SCCBRCVEC)	*SCC-BM
	move.l	(OLDSCCBVC2,pc),(SCCBRCVEC2)
	move	d0,sr
restorevect55:
	moveq	#0,d1
	IOCS	_SETMSADR		*}EXJ[\\AhXύX

restorevect60:
		moveq	#0,d0
		rts
restorevect99:
		moveq	#-1,d0
		rts


*	ύXIOCS/DOSxN^ɖ߂

rstvecttbl_iocs:
		lea	($400),a2
		bra	rstvecttbl
rstvecttbl1:
		add	d0,d0
		add	d0,d0
		addq.l	#2,a3
		move.l	(a3),(a2,d0.w)
		clr.l	(a3)+
rstvecttbl:
		move	(a3)+,d0
		bpl	rstvecttbl1
		rts


*	IOCS/DOSxN^ύXĂȂׂ

chkvecttbl_iocs:
		lea	($400),a2
chkvecttbl:
		move.l	a3,d1
chkvecttbl1:
		move	(a3)+,d0
		bmi	chkvecttbl2

		add	d0,d0
		add	d0,d0
		movea.l	d1,a4
		adda	(a3)+,a4
		addq.l	#4,a3
		cmp.l	(a2,d0.w),a4
		beq	chkvecttbl1

		moveq	#-1,d0		*xN^ύXĂ
		rts
chkvecttbl2:
		moveq	#0,d0		*xN^͕ύXĂȂ
		rts

*****************************************
*	`R[hݒ肷	*
*****************************************

setundefchr:
	move.l	(FONTKNJ16A,pc),d1	*	<+07
	cmpi.l	#fon_knj16,d1
	bcc	setundefchr1		*qnltHggp̏ꍇ
	moveq	#13,d2
	IOCS	_SETFNTADR		*$29xx`$2Fxẍݒ肷
setundefchr1:
	move.l	(FONTKNJ16C,pc),d1	*	<+08
	cmpi.l	#fon_knj16+$1d600,d1
	bcc	setundefchr2		*qnltHggp̏ꍇ
	moveq	#15,d2
	IOCS	_SETFNTADR		*$76xx`$7Exẍݒ肷
setundefchr2:
	lea	(UNDEFFLG,pc),a0
	move.b	(a0),d0
	beq	setundefchr5
	move	#'',(UNDEFCHR-UNDEFFLG,a0)	*[U[`p^[̏ꍇ
	move	#$2228,(UNDEFJIS-UNDEFFLG,a0)
	lea	(UNDEFPAT,pc),a1
	move.l	a1,(UNDEFPTR-UNDEFFLG,a0)
	rts
setundefchr4:
	lea	(UNDEFCHR,pc),a0
	move	#'',(a0)
setundefchr5:
	move	(UNDEFCHR,pc),d1
	IOCS	_SFTJIS
	tst.l	d1
	bmi	setundefchr4		*`R[hȂ
	cmpi	#$2900,d1		*	<+07
	bcs	setundefchr6
	cmpi	#$3000,d1
	bcs	setundefchr4		*$29xx`$2fxx͎gpȂ
setundefchr6:
	lea	(UNDEFJIS,pc),a0
	move	d1,(a0)
	moveq	#8,d2
	IOCS	_FNTADR
	cmpi	#2-1,d1
	bne	setundefchr4		*`R[hSpłȂ
	lea	(UNDEFPTR,pc),a0
	move.l	d0,(a0)
	rts


*	IOCTRLpf[^
		.even
IOCTRLDATA:	.dc.b	HIOCS_ID,version	*(16bytes)
IOCTRLERR:	.ds	1			*(IOCTRL̃G[R[h)
TOPADR:		.dc.l	0	*풓擪AhX(foCXhCoo^Ȃ0)

IOCSCALLFLG:	.dc.b	0	*trap #15[`ύXtO	(ύXȂ)
IOCSCONFLG:	.dc.b	0	*IOCSo̓xN^ύXtO
IOCSGRFLG:	.dc.b	0	*IOCSOtBbN`xN^ύXtO
DOSCONFLG:	.dc.b	0	*DOSo̓xN^ύXtO
IOCSMSFLG:	.dc.b	0	*IOCS}EXxN^ύXtO
VECTFLGSIZE:	.equ	*-IOCSCALLFLG
		.even

EXFONTBUF:	.dc.l	0	*gtHgobt@擪AhX(Ȃ0)
FONTBUFSIZE:	.dc.b	0	*tHgobt@TCY(0`3)
		.dc.b	0	*풓tHgobt@TCY(0`3)
CHRSELFLG::	.dc.b	0	*p('\','~','|')̕ϊȂȂ-1
VBELLFLG::	.dc.b	0	*rWuxɂȂ-1
UNDEFFLG::	.dc.b	0	*`R[h[U[p^[ɂȂ-1
USRKNJFLG::	.dc.b	0	*JIS $29xx`$2Fxx̃tHg[h		<+07
				*0:IOCS.X/:[U[tHggp/:TC.X
USRKNJ2FLG::	.dc.b	0	*JIS $76xx`$7Exx̃tHg[h		<+08
				*0:OGA/-1:[U[tHggp
CONESCFLG::	.dc.b	0	*CONDRV -eXCb`tO(ESC 0/1̖)
		.even

MSSPEED::	.dc	3	*}EXJ[\ړx( 1 ` 3 ` 4 ᑬ)
UNDEFCHR::	.dc	''	*`R[h̃LN^([U[`Ȃ'')
UNDEFPAT::			*		   tHgp^[
		.dcb.l	16/2,$aaaa5555
IOCTRLEND:
IOCTRLSIZE:	.equ	IOCTRLEND-IOCTRLDATA

CONDRVPATCH:	.ds.l	1
CONDRVFLG:	.dc.b	0	*CONDRV.SYSΉtO
		.even

UNDEFJIS::	.dc	$2228	*		    (ihrR[h)
UNDEFPTR::	.dc.l	$f00ca0	*		    tHgAhX

LINKPTR:	.ds.l	1	*foCXhCoN|C^

OLDTRAPVC:	.ds.l	1	*trap #15xN^ύXO̒l
OLDCSRVC:	.ds.l	1	*timer-C J[\_
OLDTIMERCVC:	.ds.l	1	*timer-C 荞ݏ
OLDMSCVC:	.ds.l	1	*timer-C MSCTRL
OLDSCCBVC:	.ds.l	1	*SCC-B M
OLDSCCBVC2:	.ds.l	1

*	IOCSpb`e[u

patchtbl:	.dc.l	0	*_GPALET
		.dc.l	0	*_DMAMOVE
		.dc.l	0	*_MS_PATST
		.dc.l	0	*_ONTIME

*	IOCSxN^e[u

viocsc:		.macro	callno,addr
		.dc	callno,addr-iocsctbl
old_&addr::
		.ds.l	1
		.endm

viocsg:		.macro	callno,addr
		.dc	callno,addr-iocsgtbl
old_&addr::
		.ds.l	1
		.endm

viocsm:		.macro	callno,addr
		.dc	callno,addr-iocsmtbl
old_&addr::
		.ds.l	1
		.endm

iocsctbl:
	viocsc	_DEFCHR,defchr
	viocsc	_FNTADR,fntadr
	viocsc	_FNTGET,fntget
	viocsc	_B_CURON,b_curon
	viocsc	_B_CUROFF,b_curoff
	viocsc	_B_PUTC,b_putc
	viocsc	_B_PRINT,b_print
	viocsc	_B_COLOR,b_color
	viocsc	_B_LOCATE,b_locate
	viocsc	_B_DOWN_S,b_down_s
	viocsc	_B_UP_S,b_up_s
	viocsc	_B_UP,b_up
	viocsc	_B_DOWN,b_down
	viocsc	_B_RIGHT,b_right
	viocsc	_B_LEFT,b_left
	viocsc	_B_CLR_ST,b_clr_st
	viocsc	_B_ERA_ST,b_era_st
	viocsc	_B_INS,b_ins
	viocsc	_B_DEL,b_del
	viocsc	_B_CONSOL,b_consol
	viocsc	_B_PUTMES,b_putmes
	viocsc	_B_CONMOD,b_conmod
	viocsc	_SETFNTADR,chr_adr
	viocsc	_OS_CURON,os_curon
	viocsc	_OS_CUROF,os_curof
flagjctrl:				*(/jXCb`w肳ꂽ-1)
	viocsc	_SFTJIS,sftjis
	viocsc	_JISSFT,jissft
	viocsc	_AKCONV,akconv
	.dc	-1

iocsgtbl:
	viocsg	_DRAWMODE,drawmode
	viocsg	_WIPE,wipe
	viocsg	_PSET,pset
	viocsg	_POINT,point
	viocsg	_LINE,line
	viocsg	_BOX,box
	viocsg	_FILL,fill
	viocsg	_CIRCLE,circle
	viocsg	_PAINT,paint
	viocsg	_SYMBOL,symbol
	viocsg	_GETGRM,getgrm
	viocsg	_PUTGRM,putgrm
	viocsg	_TXXLINE,txxline
	viocsg	_TXYLINE,txyline
	viocsg	_TXLINE,txline
	viocsg	_TXBOX,txbox
	viocsg	_TXFILL,txfill
	viocsg	_TXREV,txrev
	.dc	-1

iocsmtbl:
	viocsm	_SETMSADR,ms_vcs
	viocsm	_MS_INIT,ms_init
	viocsm	_MS_CURON,ms_curon
	viocsm	_MS_CUROF,ms_curof
	viocsm	_MS_STAT,ms_stat
	viocsm	_MS_GETDT,ms_getdt
	viocsm	_MS_CURGT,ms_curgt
	viocsm	_MS_CURST,ms_curst
	.dc	-1

*	DOSxN^e[u

vdosc:		.macro	callno,addr
		.dc	callno.and.$ff,addr-dosctbl
old_&addr::
		.ds.l	1
		.endm

dosctbl:
	vdosc	_PUTCHAR,putchar
	vdosc	_INPOUT,inpout
	vdosc	_PRINT,print
	vdosc	_FPUTC,fputc
 	vdosc	_FPUTS,fputs
	vdosc	_CONCTRL,conctrl
	vdosc	_WRITE,write
	.dc	-1


*****************************************
*	@IOCS	XgeW[`	*
*****************************************

		.cpu	68000
dev_strtgy::
		move.l	a5,(dev_rqhptr)	*NGXgwb_ւ̃|C^
		rts
		.cpu	CPU


*****************************************
*	@IOCS	荞݃[`	*
*****************************************

		.cpu	68000
dev_intrpt::
		movem.l	d0-d7/a0-a6,-(sp)
		movea.l	(dev_rqhptr,pc),a5
		moveq	#0,d0
		move.b	(2,a5),d0	*R}hR[h
.if 0	/* .if CPU>=68020 */
		move	(dev_jmptbl,pc,d0.w*2),d0
		jsr	(dev_jmptbl,pc,d0.w)
		ror	#8,d0
		move	d0,(3,a5)
.else
		add	d0,d0
		move	(dev_jmptbl,pc,d0.w),d0
		jsr	(dev_jmptbl,pc,d0.w)
		addq.l	#3,a5
		move.b	d0,(a5)+	*G[R[h	 (L)
		move	d0,-(sp)	;lsr	#8,d0
		move.b	(sp)+,(a5)	;move.b	d0,(a5)	*(H)
.endif
		movem.l	(sp)+,d0-d7/a0-a6
		rts
		.cpu	CPU

dev_rqhptr:	.ds.l	1		*NGXgwb_ւ̃|C^
dev_jmptbl:				*R}h[`̃Wve[u
	.dc	dev_init-dev_jmptbl	*
	.dc	dev_err-dev_jmptbl	*G[
	.dc	dev_err-dev_jmptbl	*gp
	.dc	dev_iocin-dev_jmptbl	*IOCTRLɂ
	.dc	dev_in-dev_jmptbl	*
	.dc	dev_in-dev_jmptbl	*ǂݓ
	.dc	dev_instat-dev_jmptbl	*̓Xe[^X`FbN
	.dc	dev_flush-dev_jmptbl	*̓obt@NA
	.dc	dev_out-dev_jmptbl	*o(VERIFY OFF)
	.dc	dev_out-dev_jmptbl	*o(VERIFY ON)
	.dc	dev_outstat-dev_jmptbl	*o̓Xe[^X`FbN
	.dc	dev_err-dev_jmptbl	*gp
	.dc	dev_iocout-dev_jmptbl	*IOCTRLɂo

*	G[

dev_err:
		move	#$5003,d0	*R}hR[hs
		rts

*	Xe[^X`FbN

dev_instat:
		moveq	#1,d0
		rts

*	IOCTRL

dev_iocin:
		move.l	(18,a5),d0	*]oCg
		moveq	#IOCTRLSIZE,d1
		cmp.l	d1,d0
		bls	dev_iocin0	*(o[W`FbNLɂ邽)

		move.l	d1,d0
dev_iocin0:
		movea.l	(14,a5),a0	*]obt@AhX
		lea	(IOCTRLDATA,pc),a1
		subq.l	#1,d0
@@:
		move.b	(a1)+,(a0)+	*IOCTRLf[^]
		dbra	d0,@b
dev_outstat:
dev_flush:
		moveq	#0,d0
		rts

*	IOCTRLo

dev_iocout:
		move.l	(18,a5),d0	*]oCg
		moveq	#IOCTRLSIZE,d1
		cmp.l	d1,d0
		bne	dev_err

		movea.l	(14,a5),a6	*]obt@AhX
		movea.l	a6,a0
		lea	(IOCTRLDATA,pc),a1
		moveq	#16-1,d0
dev_iocout1:
		cmpm.b	(a0)+,(a1)+	*o[Wr
		dbne	d0,dev_iocout1
		bne	dev_err

		lea	(IOCSCALLFLG-IOCTRLDATA,a6),a0
		lea	(IOCSCALLFLG,pc),a1
		bsr	restorevect	*IOCS/DOSxN^ɖ߂
		bne	dev_iocout9	*xN^ύXĂ
		bsr	setvect		*IOCS/DOSxN^ύX

		lea	(EXFONTBUF-IOCTRLDATA,a6),a0
		lea	(EXFONTBUF,pc),a1
		moveq	#(IOCTRLEND-EXFONTBUF)-1,d0
dev_iocout2:
		move.b	(a0)+,(a1)+	*̑̃tOύX
		dbra	d0,dev_iocout2

		bsr	setundefchr
		moveq	#0,d0
		move	d0,(IOCTRLERR-IOCTRLDATA,a6)
		rts

dev_iocout9:				*xN^ύXĂꍇ
		move	#-1,(IOCTRLERR-IOCTRLDATA,a6)
		moveq	#0,d0
		rts

*	

dev_in:
		move.l	(18,a5),d0	*]oCg
		subq.l	#7,d0
		bcc	dev_err

		movea.l	(14,a5),a0	*]obt@AhX
		move	#-1,(a0)	*(IOCS.Xɑ΂_~[)
		moveq	#0,d0
		rts

*	o

dev_out:
	move.l	(18,a5),d2		*]oCg
	movea.l	(14,a5),a0		*]obt@AhX
	movea.l	(EXFONTBUF,pc),a1
	move.l	a1,d0
	bne	dev_out1		*gtHgobt@gp
	lea	(RAMFONTBUF,pc),a1
dev_out1:
	movea.l	a1,a2
	bsr	lentosize		*]TCY`FbN
	bpl	dev_out2

	move.l	#fon_knj16,d1		*tHg
	moveq	#9,d2
	bsr	chr_adr
	lea	(fon_ank8),a0
	moveq	#0,d1
	move.l	(fontsize0,pc),d2

dev_out2:
	cmp.b	(FONTBUFSIZE,pc),d1
	bls	dev_out3
	move.b	(FONTBUFSIZE,pc),d1
dev_init91:
	bsr	sizetolen
dev_out3:
	move.l	(a0)+,(a1)+
	subq.l	#4,d2
	bne	dev_out3
	subq.b	#1,d1
	bcs	dev_out10
	beq	dev_out20
	subq.b	#1,d1
	beq	dev_out30

	move.l	(fontsize012,pc),d1
	add.l	a2,d1
	moveq	#15,d2
	bsr	chr_adr			*ihr񐅏tHgݒ
dev_out30:
	move.l	(fontsize01,pc),d1
	add.l	a2,d1
	moveq	#14,d2
	bsr	chr_adr			*ihrꐅ
dev_out20:
	move.l	(fontsize0,pc),d1
	add.l	a2,d1
	moveq	#13,d2
	bsr	chr_adr			*ihr񊿎
dev_out10:
	move.l	a2,d1
	moveq	#8,d2
	bsr	chr_adr			*p
	moveq	#0,d0
	rts


*	I

dev_init9:
	lea	(DATABUF,pc),a0
	lea	(RAMFONTBUF,pc),a1
	movea.l	a1,a2
	bsr	dev_init91		*tHgf[^]Eݒ

	move.b	(FONTBUFSIZE,pc),d1
	bsr	sizetolen
	adda.l	d2,a2
	move.l	#'iocs',(a2)+

		tst.b	d6
		bne	dev_init95

		move.l	a2,(14,a5)	*foCXhCoIAhX
		moveq	#0,d0
		rts
dev_init95:				*R}hCo^̏ꍇ
		lea	(dev_header,pc),a0
		suba.l	a0,a2
		clr	-(sp)
		move.l	a2,-(sp)
		DOS	_KEEPPR

lentosize:
	move.l	a0,-(sp)
	lea	(fontlentbl,pc),a0
	moveq	#0,d1
	cmpi.l	#FONTSIZE0/2,d2
	beq	lentosize9
lentosize1:
	cmp.l	(a0)+,d2
	bcs	lentosize2
	beq	lentosize9
	addq.b	#1,d1
	bra	lentosize1
lentosize2:
	moveq	#-1,d1
lentosize9:
	movea.l	(sp)+,a0
	rts

sizetolen:
	move.b	d1,d2
	ext	d2
	add	d2,d2
	add	d2,d2
	move.l	(fontlentbl,pc,d2.w),d2
	rts

fontlentbl:
fontsize0:	.dc.l	FONTSIZE0
fontsize01:	.dc.l	FONTSIZE0+FONTSIZE1
fontsize012:	.dc.l	FONTSIZE0+FONTSIZE1+FONTSIZE2
		.dc.l	FONTSIZE0+FONTSIZE1+FONTSIZE2+FONTSIZE3
		.dc.l	-1



*=======================================*
*	풓			*
*=======================================*

RAMFONTBUF:				*q`ltHg͂i[

*	

		.cpu	68000
dev_init:
		PRINT	(title_msg,pc)
.if CPU==68030
		cmpi.b	#2,(MPUTYPE)
		bcs	dev_init_err_mpu
.endif
		.cpu	CPU

		lea	(FLAG_DEV,pc),a0
		st	(a0)
		lea	(dev_jmptbl,pc),a0
		move	#dev_err-dev_jmptbl,(0,a0)

		lea	(IOCSCALLFLG,pc),a0
		moveq	#VECTFLGSIZE-1,d0
dev_init1:
		st	(a0)+		*SxN^ύX(ftHg)
		dbra	d0,dev_init1

		movea.l	(18,a5),a1	*p[^|C^
		bsr	dev_param	*p[^߂
		bmi	dev_init_err

		move.b	(FLAG_R,pc),d0
		bne	dev_init_err	*foCXhCogݍݎ/r͎ws

		bsr	mask_spurious		;XvAX荞݂𖳌
.if CPU==68000
		bsr	rte_patch
.endif
		bsr	rompatch	*IOCS ROM ւ̃pb`
		lea	(patchtbl,pc),a0	*<+03
		clr.l	(a0)+		*(foCXhCogݍ݂̏ꍇ
		clr.l	(a0)+		*	pb`͖)
		clr.l	(a0)+
		clr.l	(a0)

		bsr	copyank8	*qnltHgq`lɓ]

		lea	(VECTFLG,pc),a0
		lea	(IOCSCALLFLG,pc),a1
		moveq	#VECTFLGSIZE-1,d0
dev_init2:
		move.b	(a1),(a0)+
		sf	(a1)+
		dbra	d0,dev_init2

		bsr	csrpat_init

		lea	(VECTFLG,pc),a0
		lea	(IOCSCALLFLG,pc),a1
		bsr	setvect		*xN^ύX

		bsr	readfont_dev	*tHgt@Cǂݍ
		lea	(FONTBUFSIZE,pc),a0
		move.b	d1,(a0)+
		move.b	d1,(a0)
		move.l	d1,-(sp)
		bsr	setundefchr	*`R[hݒ肷
		move.l	(sp)+,d1

		moveq	#0,d6
		bra	dev_init9

		.cpu	68000
dev_init_err:				*̃G[
		pea	(paramerr_msg,pc)
		bra	@f
dev_init_err_mpu:
		pea	(mpu_err_msg,pc)
@@:
		DOS	_PRINT
		addq.l	#4,sp
		move	#$500c,d0
		rts
		.cpu	CPU

csrpat_init:
		move	#0<<16+$ffff,(CSRDRLINE)
		rts

*	8~16ptHgq`lɓ]

copyank8:
		lea	(fon_ank8),a0
		lea	(DATABUF,pc),a1
		move	#FONTSIZE0/4-1,d0
copyank81:
		move.l	(a0)+,(a1)+
		dbra	d0,copyank81
		rts

*	tHgt@Cobt@ɓǂݍ

readfont_dev:
		bsr	readfont_init
		movea.l	(18,a5),a1
		bra	skip_fontname
@@:
		move.l	a1,-(sp)
		bsr	readfont_sub
		movea.l	(sp)+,a1
		bmi	readfont9
skip_fontname:
		tst.b	(a1)+
		bne	skip_fontname
		move.b	(a1),d0
		beq	readfont9
		cmpi.b	#'-',d0
		beq	skip_fontname
		bra	@b

readfont_cmd:
		bsr	readfont_init
		move.l	(dev_header-$100+$20,pc),-(sp)
		addq.l	#1,(sp)
		bsr	GetArgCharInit
		addq.l	#4,sp
		bra	@f
skip_option:
		bsr	GetArgChar
		tst.b	d0
		bne	skip_option
@@:
		bsr	GetArgChar
		tst.l	d0
		beq	readfont9
		bmi	@b
		cmpi.b	#'-',d0
		beq	skip_option
		cmpi.b	#'+',d0
		beq	skip_option

		lea	(filename_buf,pc),a1
		move.b	d0,(a1)+
1:		bsr	GetArgChar
		move.b	d0,(a1)+		;t@C]
		bne	1b

		lea	(filename_buf,pc),a1
		bsr	readfont_sub
		bpl	@b
readfont9:
		tst.l	d4
		rts

readfont_sub:
		movem.l	d1-d2,-(sp)
		clr	-(sp)
		move.l	a1,-(sp)
		DOS	_OPEN		*tHgt@CI[v
		addq.l	#6,sp
		move.l	d0,d3
		bmi	readfont81	*t@CI[vłȂ

		move	#2,-(sp)
		clr.l	-(sp)
		move	d3,-(sp)
		DOS	_SEEK		*t@CTCY𓾂
		addq.l	#8,sp

		move.l	d0,d2
		bsr	lentosize
		tst.b	d1
		bmi	readfont80	*t@CTCYs

		move.b	(FLAG_DEV,pc),d0
		bne	readfont1	*(foCXhCogݍ݂̏ꍇ)

	 	lea	(DATABUF,pc),a0
	 	adda.l	d2,a0
	 	cmpa.l	(dev_header-$100+8,pc),a0
 		bcc	nomemerr	*sĂ
readfont1:
		clr	-(sp)
		clr.l	-(sp)
		move	d3,-(sp)
		DOS	_SEEK		*t@C擪ֈړ
		addq.l	#8,sp

		move.l	d2,-(sp)
		pea	(DATABUF,pc)
		move	d3,-(sp)
		DOS	_READ		*t@Cǂݍ
*		lea	(10,sp),sp
*		tst.l	d0
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	readfont80	*t@Cǂݍ߂Ȃ

		move	d3,-(sp)
		DOS	_CLOSE		*t@CN[Y
*		addq.l	#2,sp

		pea	(fontchg_msg,pc)
		DOS	_PRINT
		addq.l	#2+4,sp

		cmp.l	(sp),d1
		bcc	@f

		movem.l	(sp),d1-d2
@@:
		addq.l	#8,sp
		moveq	#0,d4
		rts

readfont81:				*tHgt@C̃G[	<+03
		pea	(nofont_msg,pc)
		bra	readfont82
readfont80:
		move	d3,-(sp)
		DOS	_CLOSE		*t@CN[Y
		addq.l	#2,sp
		pea	(badfont_msg,pc)
readfont82:
		DOS	_PRINT
		lea	(8+4,sp),sp
		bsr	copyank8	*qnltHgɖ߂
readfont_init:
		moveq	#0,d1
		move.l	(fontsize0,pc),d2
		moveq	#-1,d4
		rts


*************************************************
*	R}hCɂN		*
*************************************************

		.cpu	68000
cmd_exec:
		bra.s	@f
		.dc.b	'#HUPAIR',0
@@:
		movea.l	(8,a0),sp	*ubNIAhX{PX^bNɂ
		clr.l	-(sp)
		DOS	_SUPER		*X[p[oCU[hɓ
		addq.l	#4,sp

		PRINT	(title_msg_2,pc)
.if CPU==68030
		cmpi.b	#2,(MPUTYPE)
		bcs	mpuerr
.endif
		.cpu	CPU

		lea	(16,a0),a5	*vO̐擪AhX
		lea	(dev_jmptbl,pc),a0
		move	#dev_err-dev_jmptbl,(a0)

		pea	(DATABUF,pc)
		move	#-2,-(sp)
		DOS	_GET_PR		*g̃Xbh̏𓾂
		addq.l	#6,sp
		tst.l	d0
		ble	cmd_exec1	*XbhOG[̏ꍇ

		pea	(bgerr_msg,pc)
		bra	errout		*afł̎s͕s\
cmd_exec1:
		clr	-(sp)		*<+08(Human v1.0x̃oO)
		pea	(iocsname,pc)
		DOS	_OPEN		*'@IOCS'I[v
		addq.l	#6,sp
		move.l	d0,d7
		bmi	cmd_exec50	*I[vłȂco^̏ꍇ

		move	d7,-(sp)
		clr	-(sp)
		DOS	_IOCTRL		*'@IOCS'̑u𓾂
		addq.l	#4,sp
		move	d0,d1		*	<+08

		move	d7,-(sp)
		DOS	_CLOSE		*'@IOCS'N[Y
		addq.l	#2,sp
		moveq	#-1,d7		*(t@CfBXNv^𖳌ɂ)

		andi	#$c03f,d1
		cmpi	#$c020,d1	*(׸޲/IOCTRL/RAW MODE)
		bne	cmd_exec50	*u񂪈Ⴄ(IOCS.Xo^ς݂̏ꍇ)

		move	#1,-(sp)	*x͏݃I[v
		pea	(iocsname,pc)
		DOS	_OPEN		*'@IOCS'ēxI[v
		addq.l	#6,sp
		move.l	d0,d7
		bmi	cmd_exec50	*KI[vł͂Ô

		pea	(IOCTRLSIZE).w
	 	lea	(IOCTRLDATA,pc),a0	*	<+06
	 	clr.l	(a0)
	 	pea	(a0)
		move	d7,-(sp)
		move	#2,-(sp)
		DOS	_IOCTRL		*݂HIOCSp[^𓾂
		lea	(12,sp),sp

		lea	(IOCTRLDATA,pc),a0
		lea	(checkstr,pc),a1
		moveq	#16/4-1,d0
cmd_exec2:
		cmpm.l	(a0)+,(a1)+	*o[W`FbNpr
		dbne	d0,cmd_exec2
		bne	vererr

		move.b	(IOCSGRFLG,pc),d0
		bne	cmd_exec4

*(foCXhCoԂ畜Aꍇ)
		lea	(IOCSCALLFLG,pc),a0
		moveq	#VECTFLGSIZE-1,d0
cmd_exec3:
		st	(a0)+
		dbra	d0,cmd_exec3
cmd_exec4:
		bsr	cmd_param	*p[^̉
		bne	usage		*R}hCɌ肪

		move.b	(FLAG_M,pc),d0
		bne	alrromerr	*-mXCb`	<+03
		move.b	(FLAG_R,pc),d0
		bne	cmd_rels	*-rXCb`

		bsr	ioctrl_write	*HIOCSp[^ݒ肷
		move.b	(FLAG_F,pc),d0
		beq	@f

		move	(IOCTRLERR,pc),d0
		bne	cmd_exec5	;xN^ύXĂ
		PRINT	(initfont_msg,pc)
		bsr	freeexbuf	;-f tHg̏
@@:
		bsr	readfont_cmd
		bmi	cmd_exec5
		cmp.b	(FONTBUFSIZE,pc),d1
		bhi	cmd_exec26

		move.l	d2,-(sp)	*tHgobt@TCYꍇ
		pea	(DATABUF,pc)
		move	d7,-(sp)
		DOS	_WRITE
		lea	(10,sp),sp
cmd_exec5:
		move	(IOCTRLERR,pc),d0
		bne	vecterr		*xN^ύXĂ
		bra	exit

* ɏ풓ĂԂŃtHgobt@ȂꍇAvO̐擪
* tHgw胋[`ړA̒ɃtHgǂݍŏ풓I.

cmd_exec26:
		bsr	freeexbuf
		lea	(dev_header,pc),a1
		lea	(ex_fontset9-ex_fontset,a1),a1
		move.l	a1,(a0)+
		move.b	d1,(a0)

		bsr	ioctrl_write	*HIOCSp[^ݒ肷

		lea	(ex_fontset,pc),a0
		lea	(dev_header,pc),a1
		move	#(ex_fontset9-ex_fontset+3)/4-1,d0
cmd_exec23:
		move.l	(a0)+,(a1)+
		dbra	d0,cmd_exec23
		bsr	clear_mpu_cache

		lea	(DATABUF,pc),a0
		lea	(dev_header,pc),a1
		jmp	(ex_fontset1-ex_fontset,a1)

ioctrl_write:
		pea	(IOCTRLSIZE).w
		pea	(IOCTRLDATA,pc)
		move	d7,-(sp)
		move	#3,-(sp)
		DOS	_IOCTRL		*HIOCSp[^ݒ肷
		lea	(12,sp),sp
		rts

*	gtHgobt@ΊJ

freeexbuf:
		lea	(FONTBUFSIZE+1,pc),a0
		move.b	(a0),-(a0)
		move.l	-(a0),d0	*gtHgobt@擪AhX
		beq	freeexbuf9

		clr.l	(a0)
		subi.l	#$f0+ex_fontset9-ex_fontset,d0
		move.l	d0,-(sp)
		DOS	_MFREE		*gtHgobt@J
*		addq.l	#4,sp
*		tst.l	d0
		move.l	d0,(sp)+
		bmi	relserr		*JłȂ

		bsr	ioctrl_write
freeexbuf9:
		pea	(1)			*<+02
		pea	(DATABUF,pc)
		move	d7,-(sp)
		DOS	_WRITE			*@IOCSɃ_~[f[^(1byte)𑗂
		lea	(10,sp),sp
		rts


*	gtHgobt@ݒ胋[`

ex_fontset:
		.dc.b	'HIOCS external font buffer'
		.even
ex_fontset1:
		move.l	d2,-(sp)
		lea	(ex_fontset9,pc),a1
		move.l	a1,-(sp)
ex_fontset2:
		move.l	(a0)+,(a1)+
		subq.l	#4,d2
		bne	ex_fontset2

*		move.l	d2,-(sp)
*		pea	(ex_fontset9,pc)
		move	d7,-(sp)
		DOS	_WRITE			*tHgݒ肷
		DOS	_CLOSE			*'@IOCS'N[Y
		lea	(10,sp),sp

		lea	(dev_header,pc),a0
		suba.l	a0,a1
		clr	-(sp)		*IR[h
		move.l	a1,-(sp)	*풓TCY
		DOS	_KEEPPR		*풓I
		.quad
ex_fontset9:



*	-rXCb`(풓)

cmd_rels:
	lea	(IOCSCALLFLG,pc),a0
	moveq	#VECTFLGSIZE-1,d0
cmd_rels1:
	sf	(a0)+			*SxN^𕜋A
	dbra	d0,cmd_rels1

	move.l	(TOPADR,pc),d0
	beq	cmd_rels4		*foCXhCoo^̏ꍇ
	movea.l	d0,a0
	lea	(patchtbl-dev_header+$f0,a0),a1
	tst.l	(a1)+			*ROMpb`̃xN^ύXĂ邩ׂ
	beq	cmd_rels2

	lea	(gpalet-dev_header+$f0,a0),a2
	cmpa.l	(_GPALET*4+$400),a2
	bne	vecterr
cmd_rels2:
	tst.l	(a1)+
	beq	cmd_rels3

	lea	(dmamove-dev_header+$f0,a0),a2
	cmpa.l	(_DMAMOVE*4+$400),a2
	bne	vecterr
cmd_rels3:
	tst.l	(a1)+
	beq	cmd_rels_p1

	lea	(ms_patst-dev_header+$f0,a0),a2
	cmpa.l	(_MS_PATST*4+$400),a2
	bne	vecterr
cmd_rels_p1:
	tst.l	(a1)+
	beq	cmd_rels4

	lea	(ontime-dev_header+$f0,a0),a2
	cmpa.l	(_ONTIME*4+$400),a2
	bne	vecterr
cmd_rels4:
		bsr	ioctrl_write	*HIOCSp[^ݒ肷

	move	(IOCTRLERR,pc),d0
	bne	vecterr			*xN^ύXĂ
	bsr	freeexbuf		*gtHgobt@J

	move.l	(TOPADR,pc),d0
	beq	rels_exit		*foCXhCoo^̏ꍇ
	movea.l	d0,a0

	lea	(patchtbl-dev_header+$f0,a0),a1
	move.l	(a1)+,d1		*ROMpb`̃xN^ɖ߂	<+03
	beq	cmd_rels5

	move.l	d1,(_GPALET*4+$400)
cmd_rels5:
	move.l	(a1)+,d1
	beq	cmd_rels6

	move.l	d1,(_DMAMOVE*4+$400)
cmd_rels6:
	move.l	(a1)+,d1
	beq	cmd_rels7

	move.l	d1,(_MS_PATST*4+$400)
cmd_rels7:
	move.l	(a1)+,d1
	beq	cmd_rels8

	move.l	d1,(_ONTIME*4+$400)
cmd_rels8:
	movea.l	(LINKPTR-dev_header+$f0,a0),a1	*ÕN|C^
	move.l	($f0,a0),(a1)		*'@IOCS'foCXhCoNO
	move.l	d0,-(sp)
	DOS	_MFREE
*	addq.l	#4,sp
*	tst.l	d0
	move.l	d0,(sp)+
	bmi	relserr			*풓JłȂ
	bra	rels_exit


*	HIOCS.Xgݍ܂ĂȂꍇ

cmd_exec50:
		lea	(IOCSCALLFLG,pc),a0
		moveq	#VECTFLGSIZE-1,d0
cmd_exec51:
		st	(a0)+		*SxN^ύX(ftHg)
		dbra	d0,cmd_exec51

		bsr	mask_spurious		;XvAX荞݂𖳌
.if CPU==68000
		bsr	rte_patch
.endif
		bsr	cmd_param	*p[^̉
		bne	usage		*R}hCɌ肪

		move.b	(FLAG_R,pc),d0
		bne	nostayerr	*-rXCb`
		move.b	(FLAG_M,pc),d0
		bne	cmd_patch	*-mXCb`

		bsr	copyank8	*qnltHgq`lɓ]
		bsr	readfont_cmd	*tHgt@Cǂݍ
		lea	(FONTBUFSIZE,pc),a0
		move.b	d1,(a0)+
		move.b	d1,(a0)

	move.l	d1,-(sp)
	lea	(TOPADR,pc),a1
	move.l	a5,(a1)
	bsr	sealink			*N|C^̏I[T
	lea	LINKPTR(pc),a2
	lea	(dev_header,pc),a0
	move.l	a1,(a2)
	move.l	a0,(a1)			*N|C^Ȃ

	bsr	rompatch		*IOCS ROM ւ̃pb`
	lea	(VECTFLG,pc),a0
	lea	(IOCSCALLFLG,pc),a1
	moveq	#VECTFLGSIZE-1,d0
cmd_exec52:
	move.b	(a1),(a0)+
	sf	(a1)+
	dbra	d0,cmd_exec52

		bsr	csrpat_init

		lea	(VECTFLG,pc),a0
		lea	(IOCSCALLFLG,pc),a1
		bsr	setvect		*xN^ύX
		bsr	setundefchr	*`R[hݒ肷

		move.l	(sp)+,d1
		moveq	#-1,d6
		bra	dev_init9
relserr:				*JłȂ
	PRINT	(relserr_msg,pc)	*(Ǘ|C^ُ̈)
relserr1:
	bra	relserr1

vererr:					*풓ƃo[WႤ
	pea	(vererr_msg,pc)
	bra	errout

nomemerr:				*tHgt@Cǂݍݗps
	pea	(nomem_msg,pc)
	bra	errout

nostayerr:				*풓ĂȂ
	pea	(nostay_msg,pc)
	bra	errout

vecterr:				*xN^ύXĂ
	pea	(vecterr_msg,pc)
	bra	errout
mpuerr:
		pea	(mpu_err_msg,pc)
		bra	errout

usage:					*gp@\ďI
		bpl	@f
		PRINT	(paramerr_msg,pc)
@@:
		pea	(usage_msg,pc)
errout:					*G[o͂ďI
		DOS	_PRINT
		addq.l	#4,sp

		bsr	close_iocs
		move	#-1,-(sp)
		DOS	_EXIT2

rels_exit:
		PRINT	(rels_msg,pc)
exit:
		bsr	close_iocs
		DOS	_EXIT

close_iocs:
		move	d7,-(sp)
		bmi	@f
		DOS	_CLOSE		*'@IOCS'I[vĂN[Y
@@:
		addq.l	#2,sp
		rts

*	NULfoCXAN|C^̏I[T

sealink::
		lea	($6800),a1
sealink1:
	cmpi	#'NU',(a1)+		*Human'NUL     'To
	bne	sealink1
	cmpi.l	#'L   ',(a1)
	bne	sealink1
	cmpi	#'  ',(4,a1)
	bne	sealink1
	lea	(-16,a1),a1		*NULfoCX̃N|C^
sealink2:
	movea.l	(a1),a1			*N|C^Pǂ
	tst.l	(a1)
	bpl	sealink2
	rts


*	-mXCb`̏

cmd_patch:				*<+03
		bsr	rompatch1	*IOCS ROMւ̃pb`
		tst.l	d0
		bne	alrromerr	*łɃpb`ς

		PRINT	(rompat_msg,pc)
		clr	-(sp)
		pea	(patchend-dev_header).w
		DOS	_KEEPPR		*풓I
alrromerr:
		pea	(alrrom_msg,pc)
		bra	errout

* 68000 Ȃ move (sp)+,sr / rts  rte ꖽ߂ɂ
.if CPU==68000
rte_patch:
		tst.b	(MPUTYPE)
		bne	rte_patch_skip		;68000 ȊOȂ炻̂܂

		move	#RTE,d0
		lea	(os_curon_rte,pc),a0
		move	d0,(a0)
		move	d0, (mscdraw_rte-os_curon_rte,a0)
		move	d0,(mscerase_rte-os_curon_rte,a0)
		move	d0, (txyline_rte-os_curon_rte,a0)
		move	d0,  (txline_rte-os_curon_rte,a0)
		move	d0,  (ontime_rte-os_curon_rte,a0)
* LbVtbV͕sv.
rte_patch_skip:
		rts
.endif

.if 0
check_mpu_type:
		move.l	a1,-(sp)
		lea	(MPUTYPE),a1
		IOCS	_B_BPEEK
		subq.b	#1,d0
		movea.l	(sp)+,a1
		rts
.endif


*	hnbr@qnl̃pb`ĂsȂ

rompatch:				*<+03
	moveq	#0,d1
	moveq	#6,d2
	IOCS	_FNTADR
	lea	(FONTANK6,pc),a0
	move.l	d0,(a0)			*6~12ptHgAhX

	IOCS	_ROMVER
	rol.l	#8,d0
	cmpi.b	#$10,d0
	bne	rompatch0		*v1.1ROMȍ~̏ꍇ
	lea	(msdpatchtbl,pc),a0	*}EXJ[\\ύX
	lea	(mscdrawA,pc),a1
	bsr	mspatch
	lea	(msepatchtbl,pc),a0	*	       ύX
	lea	(msceraseA,pc),a1
	bsr	mspatch
rompatch0:
rompatch1:				*/mXCb`
	lea	(patchbegin+$8000,pc),a1	*pb`[`̃AhX
	lea	(-$8000,a1),a1		;Ƒ...
	movea.l	a1,a2
	movea.l	(_GPALET*4+$400),a0
	lea	(patchbegin-gpalet,a0),a0
rompatch2:
	move.b	(a2)+,d0
	cmp.b	(a0)+,d0
	bne	rompatch3
	tst.b	d0
	bne	rompatch2
	moveq	#1,d0			*łɃpb`ς
	rts
rompatch3:
	lea	(patchtbl,pc),a0
	move.l	(_GPALET*4+$400),(a0)+
	lea	(gpalet-patchbegin,a1),a2
	move.l	a2,(_GPALET*4+$400)
	IOCS	_ROMVER
	rol.l	#8,d0
	cmpi.b	#$10,d0
	bne	rompatch4		*v1.0 ROMł͂Ȃ

	move.l	(_DMAMOVE*4+$400),(a0)
	lea	(dmamove-patchbegin,a1),a2
	move.l	a2,(_DMAMOVE*4+$400)
rompatch4:
	addq.l	#4,a0
	IOCS	_ROMVER
	cmpi.l	#$11910111,d0
	bne	rompatch5		*v1.1 ROMł͂Ȃ

	move.l	(_MS_PATST*4+$400),(a0)
	lea	(ms_patst-patchbegin,a1),a2
	move.l	a2,(_MS_PATST*4+$400)
rompatch5:
	addq.l	#4,a0
.ifdef HONTIME
	lea	(hontime_table+60*24*4-patchbegin,a1),a2
	move.l	#60*100,d0		1=60.00b
	move.l	#60*100*60*24,d1
@@:
	move.l	d1,-(a2)
	sub.l	d0,d1
	bne	@b
.endif
	move.l	(_ONTIME*4+$400),(a0)
	lea	(ontime-patchbegin,a1),a2
	move.l	a2,(_ONTIME*4+$400)
	IOCS	_ONTIME

	moveq	#0,d0			*AhXύXsȂ
	rts


mspatch:				*}EXJ[\\/ύX
	movea.l	a0,a2
mspatch1:
	move	(a2)+,d0
	beq	mspatch9
	lea	(2,a0,d0.w),a3		*bsr.w̃fBXv[XgAhX
	move.l	a1,d0
	sub.l	a3,d0			*fBXv[XgvZ
	move	d0,(a3)
	bra	mspatch1
mspatch9:
		bra	clear_mpu_cache
**		rts

msdpatchtbl:				*}EXJ[\\ĂяoAhX
	.dc	msdpatch1-msdpatchtbl
	.dc	msdpatch2-msdpatchtbl
	.dc	0
msepatchtbl:				*}EXJ[\ĂяoAhX
	.dc	msepatch1-msepatchtbl
	.dc	msepatch2-msepatchtbl
	.dc	0


*	XvAX荞݂̖

mask_spurious:
		movem.l	d0/a0,-(sp)
		move	#RTE,d0
		movea.l	(SPURIVEC),a0
		cmp	(a0),d0
		beq	mask_spurious_end	; rte ɂȂĂ炻̂܂
.if 1
		lea	($ff0000),a0
.else
		lea	($fc0000),a0
.endif
@@:		cmp	(a0)+,d0		;ROM  rte T
		bne	@b
		subq.l	#2,a0
		move.l	a0,(SPURIVEC)		;rte ̃AhXݒ
mask_spurious_end:
		movem.l	(sp)+,d0/a0
		rts


*	p[^̉

cmd_param:				*R}hCp[^Xg
		pea	(1,a2)
		bsr	GetArgCharInit
		addq.l	#4,sp
		bra	@f
dev_param:				*foCXhCop[^
		tst.b	(a1)+
		bne	dev_param
		lea	(ArgPtr,pc),a0
		move.l	a1,(a0)
		st	(a0)
@@:
param1:
		bsr	GetArgChar
		tst.l	d0
		beq	param9
		bmi	param1			;""

		moveq	#-1,d3		*-[XCb`]
		cmpi.b	#'-',d0
		beq	param2
		moveq	#0,d3		*+[XCb`] c@\w𔽓]
		cmpi.b	#'+',d0
		beq	param2

		moveq	#90-2,d1
@@:
		bsr	GetArgChar
		tst.b	d0
		dbeq	d1,@b
		beq	param1
		bra	param8			;t@C
param2:
		bsr	GetArgChar
		tst.b	d0
		beq	param8			;-/+̂
next_option:
		tst.b	d0
		beq	param1
		cmpi.b	#'?',d0
		beq	param_h
		ori.b	#$20,d0
		lea	(param_table-2,pc),a0
@@:
		addq.l	#2,a0
		move	(a0)+,d1
		beq	param8
		cmp.b	d0,d1
		bne	@b
		adda	(a0),a0
		jmp	(a0)
param8:
		moveq	#-1,d0		*p[^̎wɌ肪
		rts

param_table:
		.irpc	%a,cdefghjlmrsuv
		.dc	'&%a',param_%a-$
		.endm
		.dc	0

param_h:
		moveq	#1,d0		*gp@\
param9:
		rts			;d0.l=0

param_d:				*-d[0/1]
		lea	(DOSCONFLG,pc),a0
		move.b	d3,(a0)
		not.b	(a0)
		bra	paramsw1

param_m:				*-m
		bsr	GetArgChar
		cmpi.b	#'s',d0
		beq	param_ms
		cmpi.b	#'S',d0
		beq	param_ms
		cmpi.b	#'h',d0
		beq	param_mh
		cmpi.b	#'H',d0
		beq	param_mh

		lea	(FLAG_M,pc),a0
		st	(a0)
		bra	next_option

param_ms:				*-ms[0/1]	<+08
		lea	(IOCSMSFLG,pc),a0
		bsr	GetArgChar
		cmpi.b	#'0',d0
		bcs	param_ms2
		beq	param_ms0
		cmpi.b	#'4',d0
		bhi	param_ms2

		moveq	#'5',d1			;-ms1`-ms4 }EXJ[\ړx̎w
		sub	d0,d1
		bsr	GetArgChar
param_ms1:
		st	(a0)
		lea	(MSSPEED,pc),a0
		move	d1,(a0)			;1`4  4`1
		bra	next_option
param_ms2:
		moveq	#3,d1
		tst.b	d3
		bne	param_ms1		;-ms = -ms2

		st	(a0)			;+ms tbN̂
		bra	next_option
param_ms0:
		sf	(a0)			;-ms0 ROMɖ߂
		bra	paramsw9

param_mh:					;-mh[0/1]
		moveq	#$1f,d2			;5MHz
		bsr	check_param01
		beq	@f
		moveq	#$2f,d2			;7.5MHz
@@:
		move	sr,-(sp)
		ori	#$700,sr
		lea	(_SCCCMD_B),a0
		tst.b	(a0)			;ǂ
		moveq	#14,d1
		move.b	d1,(a0)
		move.b	#%000_0001_0,(a0)	;{[[gWFl[^~

		move.b	#12,(a0)
		move.b	d2,(a0)			;tc()
		lsr	#8,d2
		move.b	#13,(a0)
		move.b	d2,(a0)			;tc()

		move.b	d1,(a0)
		move.b	#%000_0001_1,(a0)	;{[[gWFl[^
		move	(sp)+,sr
		bra	next_option


* -x -x1 +x0	d1.b = -1
* +x -x0 +x1	d1.b =  0
check_param01:
		move.b	d3,d1
		bsr	GetArgChar
		cmpi.b	#'1',d0
		beq	@f			;-x=-x1A+x=+x1
		cmpi.b	#'0',d0
		bne	9f
		not.b	d1			;-x0=+xA+x0=-x
@@:		bsr	GetArgChar
9:		tst.b	d1
		rts


param_g:				*-g[0/1]
		bsr	check_param01
		lea	(IOCSCONFLG,pc),a0
		move.b	d1,(a0)			;IOCSCONFLG
		addq.l	#DOSCONFLG-IOCSCONFLG,a0
		move.b	d1,(a0)+		;DOSCONFLG
		move.b	d1,(a0)			;IOCSMSFLG
		bra	next_option

param_r:				*-r
		lea	(FLAG_R,pc),a0
		bra	paramset
param_f:				*-f
		lea	(FLAG_F,pc),a0
		bra	paramset
paramset:
		st	(a0)
paramsw9:
		bsr	GetArgChar
		bra	next_option

param_j:				*-j
		lea	(flagjctrl,pc),a0
		move	#-1,(a0)
		bra	paramsw9

param_e:
		lea	(CONESCFLG,pc),a0
		bra	paramsw
param_l:
		lea	(USRKNJ2FLG,pc),a0
		bra	paramsw
param_s:
		lea	(CHRSELFLG,pc),a0
		bra	paramsw
param_v:
		lea	(VBELLFLG,pc),a0
		bra	paramsw
paramsw:
		move.b	d3,(a0)
paramsw1:
		bsr	GetArgChar
paramsw2:
		cmpi.b	#'1',d0
		beq	paramsw9
		cmpi.b	#'0',d0
		bne	next_option

		not.b	(a0)
		bra	paramsw9

param_u:				*-u[0/1/2]	<+07
		lea	(USRKNJFLG,pc),a0
		move.b	d3,(a0)
		bsr	GetArgChar
		cmpi.b	#'2',d0
		bne	paramsw2

		move.b	#1,(a0)			;-u2
		bra	paramsw9

param_c:
		lea	(UNDEFFLG,pc),a0
		lea	(UNDEFPAT,pc),a2
		bsr	GetArgChar
		tst.b	d0
		spl	(a0)
		beq	param_c2
		bpl	param_c1

		lea	(UNDEFCHR,pc),a0	;-c
		move.b	d0,(a0)+
		bsr	GetArgChar
		move.b	d0,(a0)+
		beq	param1
		bra	paramsw9
param_c1:				*-c[pattern..]
		moveq	#32-1,d2
@@:
		bsr	gethex
		bmi	next_option

		move.b	d1,(a2)+
		dbra	d2,param_c1
		st	(a0)
		bra	paramsw9
param_c2:
		move.l	#$aaaa_5555,d0		;-c bV
		moveq	#8-1,d1
param_c3:
		move.l	d0,(a2)+
		dbra	d1,param_c3
		bra	param1

gethex:
		bsr	getahex
		bmi	@f
		move.b	d0,d1
		lsl.b	#4,d1
		bsr	getahex
		bmi	@f
		or.b	d0,d1
		moveq	#0,d0
@@:
		rts
getahex:
		bsr	GetArgChar
		cmpi.b	#'0',d0
		bcs	getahex9
		cmpi.b	#'9',d0
		bls	getahex1		;0-9

		cmpi.b	#'_',d0
		beq	getahex

		cmpi.b	#'A',d0
		bcs	getahex9
		cmpi.b	#'F',d0
		bls	getahex2

		cmpi.b	#'a',d0
		bcs	getahex9
		cmpi.b	#'f',d0
		bhi	getahex9

		andi.b	#$df,d0
getahex2:
		subq.b	#'A'-('9'+1),d0		;a-fA-F
getahex1:
		sub.b	#'0',d0
		rts
getahex9:
		moveq	#-1,d1
		rts

* HUPAIRfR[h ------------------------------ *

GetArgChar:
		movem.l	d1/a0-a1,-(sp)
		moveq	#0,d0
		lea	(ArgPtr,pc),a0
		movea.l	(a0),a1
		move.b	(a0),d1
		bpl	GetArgChar_next

		move.b	(a1)+,d0
		bne	GetArgChar_end
		tst.b	(a1)
		bne	GetArgChar_abort2
		subq.l	#1,a1
		bra	GetArgChar_end
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_abort
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		bne	GetArgChar_end
GetArgChar_quate:
		move.b	d0,d1
		bra	GetArgChar_next
GetArgChar_end:
		move.l	a1,(a0)
		move.b	d1,(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next
GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		subq.l	#1,a1
GetArgChar_abort2:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_end

GetArgCharInit:
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		subq.l	#1,a1
		lea	(ArgPtr,pc),a0
		move.l	a1,(a0)
		movem.l	(sp)+,a0-a1
		rts

* Data Section -------------------------------- *
*	bZ[Wf[^

		.data
iocsname:	.dc.b	'@IOCS',0

title_msg:	.dc.b	CR,LF
title_msg_2:	.dc.b	program
.if CPU==68030
		.dc.b	' for X68030'
.endif
		.dc.b	' version ',version,' (C)1990-95 SHARP / Y.Nakamura, ',date,' ',author,'.'
crlf_msg:	.dc.b	CR,LF,0

paramerr_msg:	.dc.b	'IvVwɊԈႢ܂.',CR,LF,0
mpu_err_msg:	.dc.b	' MPU ł͎gpł܂.',CR,LF,0

usage_msg:	.dc.b	'usage : hiocs [option] [fontfile]',CR,LF
		.dc.b	'	-c[chr]	oCg`R[h̃tHgw.',CR,LF
		.dc.b	'	-d	DOSR\[o͂𑬂Ȃ.',CR,LF
		.dc.b	'	-e	ESC 0-3𖳌ɂ.',CR,LF
		.dc.b	'	-f	tHg.',CR,LF
		.dc.b	'	-g	OtBbN`̂ݑ.',CR,LF
		.dc.b	'	-j	oCg`R[hT|[gȂ.',CR,LF
		.dc.b	'	-l[n]	JISR[h$7621`$7e7ẽtHg[hw(n:0`1).',CR,LF
		.dc.b	'	-m	ROM̏Ĉݍs.',CR,LF
		.dc.b	'	-ms[n]	}EXJ[\̈ړxw(n:1`4 W2).',CR,LF
		.dc.b	'	-mh	SCCNbN7.5MHz[hɂ.',CR,LF
		.dc.b	'	-s	p(\,~,|)̃XCb`w𖳎.',CR,LF
		.dc.b	'	-u[n]	JISR[h$2921`$2f7ẽtHg[hw(n:0`2).',CR,LF
		.dc.b	'	-v	r[vrWAxɂ.',CR,LF
		.dc.b	'	-r	gݍ݉.',CR,LF
		.dc.b	0

fontchg_msg:	.dc.b	'[U[tHgf[^ɐ؂ւ܂.',CR,LF,0

nofont_msg:	.dc.b	'tHgt@C܂.',CR,LF,0

badfont_msg:	.dc.b	'tHgt@Cُł.',CR,LF,0

initfont_msg:	.dc.b	'tHgf[^܂.',CR,LF,0

bgerr_msg:	.dc.b	'obNOhvZXł̏͂ł܂.',CR,LF,0

vererr_msg:	.dc.b	'HIOCS̏풓ƃo[WႢ܂.',CR,LF,0

vecterr_msg:	.dc.b	'xN^Ă܂.',CR,LF,0

rels_msg:	.dc.b	'IOCSɖ߂܂.',CR,LF,0

nostay_msg:	.dc.b	'HIOCS͑gݍ܂Ă܂.',CR,LF,0

nomem_msg:	.dc.b	'eʂsĂ܂.',CR,LF,0

relserr_msg:	.dc.b	'Ǘ񂪔j󂳂Ă܂I ZbgĂ.'
		.dc.b	$1b,'[>5l',0

alrrom_msg:	.dc.b	'łɃxN^Ă܂.',CR,LF,0

rompat_msg:	.dc.b	'IOCS ROMɃpb`ĂsȂ܂.',CR,LF,0

* Block Storage Section -------------- *

		.bss
		.even

ArgPtr:		.ds.l	1

*	ÑXCb`wtO

FLAG_R:		.ds.b	1		*/r  풓
FLAG_M:		.ds.b	1		*/m  v1.1 IOCS _MS_PATST̃oOpb`
FLAG_F:		.ds.b	1		*/f  tHgt@Cw
FLAG_DEV:	.ds.b	1		*foCXhCoNtO

VECTFLG:	.ds.b	5		*=VECTFLGSIZE

		.even
filename_buf:	.ds.b	90
DATABUF:	.ds.b	$1000		*Gpf[^obt@


		.end	cmd_exec

* End of File ------------------------- *

*	$Log:	HIOCS.HA_ $
* Revision 1.6  93/02/15  00:39:30  YuNK
* CONFIG.SYS program= sł̓o^ł悤ɂB
* 
* Revision 1.5  92/11/17  23:41:06  YuNK
* 풓Ƀ}EXf[^M̏I҂Ȃ悤ɂ
* 
* Revision 1.4  92/11/09  00:09:22  YuNK
* ꕔ̃xN^ύXύXB
* 
* Revision 1.3  92/10/11  00:27:38  YuNK
* gtHggpɏ풓ƁȀ풓ɃtHgoOC
* 
* Revision 1.2  92/09/18  13:39:10  YuNK
* CONDRV.SYS풓Timer-C荞ݏύXȂ悤ɂ
* 
* Revision 1.1  92/09/14  01:15:02  YuNK
* Initial revision
* 
